]> git.ipfire.org Git - people/pmueller/ipfire-2.x.git/blob - make.sh
Don't provide ssh keys in the update to 2.3.
[people/pmueller/ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2007 IPFire-Team <info@ipfire.org>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.3"
28 GIT_BRANCH=master:master # Version number
29 SLOGAN="www.ipfire.org" # Software slogan
30 CONFIG_ROOT=/var/ipfire # Configuration rootdir
31 NICE=10 # Nice level
32 MAX_RETRIES=1 # prefetch/check loop
33 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
34 MACHINE=`uname -m`
35 GIT_TAG=$(git tag | tail -1)
36
37 IPFVER="full" # Which versions should be compiled? (full|devel)
38
39 # Debian specific settings
40 if [ ! -e /etc/debian_version ]; then
41 FULLPATH=`which $0`
42 else
43 if [ -x /usr/bin/realpath ]; then
44 FULLPATH=`/usr/bin/realpath $0`
45 else
46 echo "ERROR: Need to do apt-get install realpath"
47 exit 1
48 fi
49 fi
50
51 PWD=`pwd`
52 BASENAME=`basename $0`
53 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
54 LOGFILE=$BASEDIR/log/_build.preparation.log
55 export BASEDIR LOGFILE
56 DIR_CHK=$BASEDIR/cache/check
57 mkdir $BASEDIR/log/ 2>/dev/null
58
59 # Include funtions
60 . tools/make-functions
61
62 if [ -f .config ]; then
63 . .config
64 else
65 echo -e "${BOLD}No configuration found!${NORMAL}"
66 echo -ne "Do you want to create one (y/N)?"
67 read CREATE_CONFIG
68 echo ""
69 if [ "$CREATE_CONFIG" == "y" ]; then
70 make_config
71 fi
72 fi
73
74 if [ -z $EDITOR ]; then
75 for i in nano emacs vi; do
76 EDITOR=$(which $i 2>/dev/null)
77 if ! [ -z $EDITOR ]; then
78 export EDITOR=$EDITOR
79 break
80 fi
81 done
82 [ -z $EDITOR ] && exiterror "You should have installed an editor."
83 fi
84
85 prepareenv() {
86 ############################################################################
87 # #
88 # Are we running the right shell? #
89 # #
90 ############################################################################
91 if [ ! "$BASH" ]; then
92 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
93 fi
94
95 if [ -z "${BASH_VERSION}" ]; then
96 exiterror "Not running BASH shell."
97 fi
98
99
100 ############################################################################
101 # #
102 # Trap on emergency exit #
103 # #
104 ############################################################################
105 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
106
107
108 ############################################################################
109 # #
110 # Resetting our nice level #
111 # #
112 ############################################################################
113 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
114 renice $NICE $$ > /dev/null
115 if [ `nice` != "$NICE" ]; then
116 beautify message FAIL
117 exiterror "Failed to set correct nice level"
118 else
119 beautify message DONE
120 fi
121
122
123 ############################################################################
124 # #
125 # Checking if running as root user #
126 # #
127 ############################################################################
128 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
129 if [ `id -u` != 0 ]; then
130 beautify message FAIL
131 exiterror "Not building as root"
132 else
133 beautify message DONE
134 fi
135
136
137 ############################################################################
138 # #
139 # Checking for necessary temporary space #
140 # #
141 ############################################################################
142 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
143 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
144 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
145 if (( 2048000 > $BASE_ASPACE )); then
146 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
147 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
148 beautify message FAIL
149 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
150 fi
151 else
152 beautify message DONE
153 fi
154
155 ############################################################################
156 # #
157 # Building Linux From Scratch system #
158 # #
159 ############################################################################
160 # Set umask
161 umask 022
162
163 # Set LFS Directory
164 LFS=$BASEDIR/build
165
166 # Check /tools symlink
167 if [ -h /tools ]; then
168 rm -f /tools
169 fi
170 if [ ! -a /tools ]; then
171 ln -s $BASEDIR/build/tools /
172 fi
173 if [ ! -h /tools ]; then
174 exiterror "Could not create /tools symbolic link."
175 fi
176
177 # Setup environment
178 set +h
179 LC_ALL=POSIX
180 if [ -z $MAKETUNING ]; then
181 MAKETUNING="-j6"
182 fi
183 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
184 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
185
186 # Make some extra directories
187 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
188 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
189 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
190 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
191
192 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
193 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
194
195 # Make all sources and proc available under lfs build
196 mount --bind /dev $BASEDIR/build/dev
197 mount --bind /dev/pts $BASEDIR/build/dev/pts
198 mount --bind /dev/shm $BASEDIR/build/dev/shm
199 mount --bind /proc $BASEDIR/build/proc
200 mount --bind /sys $BASEDIR/build/sys
201 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
202 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
203 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
204 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
205 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
206 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
207 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
208 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
209 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
210
211 # This is a temporary hack!!!
212 if [ ! -f /tools/bin/hostname ]; then
213 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
214 fi
215
216 # Run LFS static binary creation scripts one by one
217 export CCACHE_DIR=$BASEDIR/ccache
218 export CCACHE_HASHDIR=1
219
220 # Remove pre-install list of installed files in case user erase some files before rebuild
221 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
222 }
223
224 buildtoolchain() {
225 LOGFILE="$BASEDIR/log/_build.toolchain.log"
226 export LOGFILE
227 ORG_PATH=$PATH
228 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
229 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
230 lfsmake1 ccache
231 lfsmake1 binutils PASS=1
232 lfsmake1 gcc PASS=1
233 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
234 lfsmake1 linux-libc-header
235 lfsmake1 glibc
236 lfsmake1 cleanup-toolchain PASS=1
237 lfsmake1 tcl
238 lfsmake1 expect
239 lfsmake1 dejagnu
240 lfsmake1 gcc PASS=2
241 lfsmake1 binutils PASS=2
242 lfsmake1 ncurses
243 lfsmake1 bash
244 lfsmake1 bzip2
245 lfsmake1 coreutils
246 lfsmake1 diffutils
247 lfsmake1 findutils
248 lfsmake1 gawk
249 lfsmake1 gettext
250 lfsmake1 grep
251 lfsmake1 gzip
252 lfsmake1 m4
253 lfsmake1 make
254 lfsmake1 patch
255 lfsmake1 perl
256 lfsmake1 sed
257 lfsmake1 tar
258 lfsmake1 texinfo
259 lfsmake1 util-linux
260 lfsmake1 cleanup-toolchain PASS=2
261 export PATH=$ORG_PATH
262 }
263
264 buildbase() {
265 LOGFILE="$BASEDIR/log/_build.base.log"
266 export LOGFILE
267 lfsmake2 stage2
268 lfsmake2 linux-libc-header
269 lfsmake2 man-pages
270 lfsmake2 glibc
271 lfsmake2 cleanup-toolchain PASS=3
272 lfsmake2 binutils
273 lfsmake2 gcc
274 lfsmake2 berkeley
275 lfsmake2 coreutils
276 lfsmake2 iana-etc
277 lfsmake2 m4
278 lfsmake2 bison
279 lfsmake2 ncurses
280 lfsmake2 procps
281 lfsmake2 sed
282 lfsmake2 libtool
283 lfsmake2 perl
284 lfsmake2 readline
285 lfsmake2 zlib
286 lfsmake2 autoconf
287 lfsmake2 automake
288 lfsmake2 bash
289 lfsmake2 bzip2
290 lfsmake2 diffutils
291 lfsmake2 e2fsprogs
292 lfsmake2 ed
293 lfsmake2 file
294 lfsmake2 findutils
295 lfsmake2 flex
296 lfsmake2 gawk
297 lfsmake2 gettext
298 lfsmake2 grep
299 lfsmake2 groff
300 lfsmake2 gzip
301 lfsmake2 inetutils
302 lfsmake2 iproute2
303 lfsmake2 kbd
304 lfsmake2 less
305 lfsmake2 libaal
306 lfsmake2 make
307 lfsmake2 man
308 lfsmake2 mktemp
309 lfsmake2 modutils
310 lfsmake2 mtd
311 lfsmake2 net-tools
312 lfsmake2 patch
313 lfsmake2 psmisc
314 lfsmake2 reiser4progs
315 lfsmake2 shadow
316 lfsmake2 sysklogd
317 lfsmake2 sysvinit
318 lfsmake2 tar
319 lfsmake2 texinfo
320 lfsmake2 udev
321 lfsmake2 util-linux
322 lfsmake2 vim
323 lfsmake2 grub
324 }
325
326 buildipfire() {
327 LOGFILE="$BASEDIR/log/_build.ipfire.log"
328 export LOGFILE
329 ipfiremake configroot
330 ipfiremake backup
331 ipfiremake dhcp
332 ipfiremake dhcpcd
333 ipfiremake libusb
334 ipfiremake libpcap
335 ipfiremake ppp
336 ipfiremake rp-pppoe
337 ipfiremake unzip
338 ipfiremake linux
339 ipfiremake atl2
340 ipfiremake kqemu
341 ipfiremake v4l-dvb
342 ipfiremake madwifi
343 ipfiremake alsa KMOD=1
344 ipfiremake openswan KMOD=1
345 ipfiremake pkg-config
346 ipfiremake linux-atm
347 ipfiremake cpio
348 ipfiremake klibc
349 ipfiremake mkinitcpio
350 ipfiremake udev KLIBC=1
351 ipfiremake expat
352 ipfiremake gdbm
353 ipfiremake gmp
354 ipfiremake pam
355 ipfiremake openssl
356 ipfiremake curl
357 ipfiremake python
358 ipfiremake libnet
359 ipfiremake libidn
360 ipfiremake libjpeg
361 ipfiremake libpng
362 ipfiremake libtiff
363 ipfiremake libart
364 ipfiremake freetype
365 ipfiremake gd
366 ipfiremake popt
367 ipfiremake pcre
368 ipfiremake slang
369 ipfiremake newt
370 ipfiremake libcap
371 ipfiremake pciutils
372 ipfiremake usbutils
373 ipfiremake libxml2
374 ipfiremake libxslt
375 ipfiremake BerkeleyDB
376 ipfiremake mysql
377 ipfiremake cyrus-sasl
378 ipfiremake openldap
379 ipfiremake apache2
380 ipfiremake php
381 ipfiremake apache2 PASS=C
382 ipfiremake arping
383 ipfiremake beep
384 ipfiremake bind
385 ipfiremake cdrtools
386 ipfiremake dnsmasq
387 ipfiremake dosfstools
388 ipfiremake squashfstools
389 ipfiremake reiserfsprogs
390 ipfiremake xfsprogs
391 ipfiremake sysfsutils
392 ipfiremake fuse
393 ipfiremake ntfs-3g
394 ipfiremake ethtool
395 ipfiremake ez-ipupdate
396 ipfiremake fcron
397 ipfiremake perl-GD
398 ipfiremake GD-Graph
399 ipfiremake GD-TextUtil
400 ipfiremake gnupg
401 ipfiremake hdparm
402 ipfiremake sdparm
403 ipfiremake mtools
404 ipfiremake initscripts
405 ipfiremake whatmask
406 ipfiremake iptables
407 ipfiremake libupnp
408 ipfiremake linux-igd
409 ipfiremake ipaddr
410 ipfiremake iptstate
411 ipfiremake iputils
412 ipfiremake l7-protocols
413 ipfiremake mISDN
414 ipfiremake capi4k-utils
415 ipfiremake hwdata
416 ipfiremake kudzu
417 ipfiremake logrotate
418 ipfiremake logwatch
419 ipfiremake misc-progs
420 ipfiremake nano
421 ipfiremake nasm
422 ipfiremake URI
423 ipfiremake HTML-Tagset
424 ipfiremake HTML-Parser
425 ipfiremake Compress-Zlib
426 ipfiremake Digest
427 ipfiremake Digest-SHA1
428 ipfiremake Digest-HMAC
429 ipfiremake libwww-perl
430 ipfiremake Net-DNS
431 ipfiremake Net-IPv4Addr
432 ipfiremake Net_SSLeay
433 ipfiremake IO-Stringy
434 ipfiremake Unix-Syslog
435 ipfiremake Mail-Tools
436 ipfiremake MIME-Tools
437 ipfiremake Net-Server
438 ipfiremake Convert-TNEF
439 ipfiremake Convert-UUlib
440 ipfiremake Archive-Tar
441 ipfiremake Archive-Zip
442 ipfiremake Text-Tabs+Wrap
443 ipfiremake Locale-Country
444 ipfiremake XML-Parser
445 ipfiremake python-setuptools
446 ipfiremake python-clientform
447 ipfiremake python-mechanize
448 ipfiremake python-feedparser
449 ipfiremake python-rssdler
450 ipfiremake glib
451 ipfiremake GeoIP
452 ipfiremake fwhits
453 ipfiremake noip_updater
454 ipfiremake ntp
455 ipfiremake openssh
456 ipfiremake rrdtool
457 ipfiremake setserial
458 ipfiremake setup
459 ipfiremake snort
460 ipfiremake oinkmaster
461 ipfiremake squid
462 ipfiremake squidguard
463 ipfiremake calamaris
464 ipfiremake tcpdump
465 ipfiremake traceroute
466 ipfiremake vlan
467 ipfiremake wireless
468 ipfiremake libsafe
469 ipfiremake pakfire
470 ipfiremake java
471 ipfiremake spandsp
472 ipfiremake lzo
473 ipfiremake openvpn
474 ipfiremake pammysql
475 ipfiremake cups
476 ipfiremake ghostscript
477 ipfiremake foomatic
478 ipfiremake hplip
479 ipfiremake samba
480 ipfiremake sudo
481 ipfiremake mc
482 ipfiremake wget
483 ipfiremake bridge-utils
484 ipfiremake screen
485 ipfiremake hddtemp
486 ipfiremake smartmontools
487 ipfiremake htop
488 ipfiremake postfix
489 ipfiremake fetchmail
490 ipfiremake cyrus-imapd
491 ipfiremake openmailadmin
492 ipfiremake clamav
493 ipfiremake spamassassin
494 ipfiremake amavisd
495 ipfiremake alsa
496 ipfiremake mpfire
497 ipfiremake guardian
498 ipfiremake libid3tag
499 ipfiremake libmad
500 ipfiremake libogg
501 ipfiremake libvorbis
502 ipfiremake libdvbpsi
503 ipfiremake lame
504 ipfiremake sox
505 ipfiremake libshout
506 ipfiremake icecast
507 ipfiremake icegenerator
508 ipfiremake mpd
509 ipfiremake mpc
510 ipfiremake xvid
511 ipfiremake libmpeg2
512 ipfiremake cmake
513 ipfiremake libpri
514 ipfiremake asterisk
515 ipfiremake gnump3d
516 ipfiremake libsigc++
517 ipfiremake applejuice
518 ipfiremake ocaml
519 ipfiremake mldonkey
520 ipfiremake libtorrent
521 ipfiremake rtorrent
522 ipfiremake ipfireseeder
523 ipfiremake rsync
524 ipfiremake tcpwrapper
525 ipfiremake portmap
526 ipfiremake nfs
527 ipfiremake nmap
528 ipfiremake ncftp
529 ipfiremake etherwake
530 ipfiremake bwm-ng
531 ipfiremake tripwire
532 ipfiremake sysstat
533 ipfiremake vsftpd
534 ipfiremake which
535 ipfiremake openswan
536 ipfiremake lsof
537 ipfiremake centerim
538 ipfiremake br2684ctl
539 ipfiremake pcmciautils
540 ipfiremake lm_sensors
541 ipfiremake collectd
542 ipfiremake lcd4linux
543 ipfiremake tcptrack
544 ipfiremake teamspeak
545 ipfiremake elinks
546 ipfiremake igmpproxy
547 ipfiremake fbset
548 ipfiremake sdl
549 ipfiremake qemu
550 ipfiremake sane
551 ipfiremake netpbm
552 ipfiremake phpSANE
553 ipfiremake tunctl
554 ipfiremake nagios
555 ipfiremake ebtables
556 ipfiremake fontconfig
557 ipfiremake freefont
558 ipfiremake directfb
559 ipfiremake dfb++
560 ipfiremake ffmpeg
561 ipfiremake videolan
562 ipfiremake vdr
563 ipfiremake w_scan
564 ipfiremake git
565 ipfiremake squidclamav
566 ipfiremake bc
567 ipfiremake esniper
568 ipfiremake vnstat
569 ipfiremake vnstati
570 ipfiremake wpa_supplicant
571 ipfiremake hostapd
572 ipfiremake urlgrabber
573 ipfiremake syslinux
574 ipfiremake tftp-hpa
575 ipfiremake cpufrequtils
576 ipfiremake dbus
577 ipfiremake bluetooth
578 ipfiremake gutenprint
579 ipfiremake apcupsd
580 ipfiremake iperf
581 ipfiremake netcat
582 ipfiremake 7zip
583 ipfiremake lynis
584 echo Build on $HOSTNAME > $BASEDIR/build/var/ipfire/firebuild
585 cat /proc/version >> $BASEDIR/build/var/ipfire/firebuild
586 echo >> $BASEDIR/build/var/ipfire/firebuild
587 git log -1 >> $BASEDIR/build/var/ipfire/firebuild
588 echo >> $BASEDIR/build/var/ipfire/firebuild
589 git status >> $BASEDIR/build/var/ipfire/firebuild
590 echo >> $BASEDIR/build/var/ipfire/firebuild
591 cat /proc/cpuinfo >> $BASEDIR/build/var/ipfire/firebuild
592 }
593
594 buildinstaller() {
595 # Run installer scripts one by one
596 LOGFILE="$BASEDIR/log/_build.installer.log"
597 export LOGFILE
598 ipfiremake as86
599 ipfiremake mbr
600 ipfiremake memtest
601 installmake linux-libc-header
602 installmake binutils
603 ipfiremake uClibc PASS=1
604 ipfiremake gcc INST=1
605 installmake uClibc PASS=2
606 installmake gcc INST=2
607 installmake uClibc PASS=3
608 installmake busybox
609 installmake udev
610 installmake slang
611 installmake newt
612 installmake gettext
613 installmake kbd
614 installmake popt
615 installmake sysvinit
616 installmake misc-progs
617 installmake libaal
618 installmake reiser4progs
619 installmake reiserfsprogs
620 installmake sysfsutils
621 installmake util-linux
622 installmake pciutils
623 installmake zlib
624 installmake mtd
625 installmake wget
626 installmake hwdata
627 installmake kudzu
628 installmake pcmciautils
629 installmake installer
630 installmake initrd
631 }
632
633 buildpackages() {
634 LOGFILE="$BASEDIR/log/_build.packages.log"
635 export LOGFILE
636 echo "... see detailed log in _build.*.log files" >> $LOGFILE
637
638 installmake strip
639
640 # Generating list of packages used
641 echo -n "Generating packages list from logs" | tee -a $LOGFILE
642 rm -f $BASEDIR/doc/packages-list
643 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
644 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
645 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
646 fi
647 done
648 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
649 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
650 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
651 rm -f $BASEDIR/doc/packages-list
652 # packages-list.txt is ready to be displayed for wiki page
653 beautify message DONE
654
655 # Update changelog
656 cd $BASEDIR
657 $0 git log
658
659 # Create images for install
660 ipfiremake cdrom ED=full
661
662 # Check if there is a loop device for building in virtual environments
663 if [ -e /dev/loop/0 ] || [ -e /dev/loop0 ]; then
664 ipfiremake usb-stick
665 fi
666
667 # Create updater package
668 ipfiremake updater
669 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
670
671 ipfirepackages
672
673 # Cleanup
674 stdumount
675 rm -rf $BASEDIR/build/tmp/*
676
677 # Generating total list of files
678 echo -n "Generating files list from logs" | tee -a $LOGFILE
679 rm -f $BASEDIR/log/FILES
680 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
681 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
682 echo "##" >>$BASEDIR/log/FILES
683 echo "## `basename $i`" >>$BASEDIR/log/FILES
684 echo "##" >>$BASEDIR/log/FILES
685 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
686 fi
687 done
688 beautify message DONE
689
690 cd $PWD
691 }
692
693 ipfirepackages() {
694 ipfiremake core-updates
695 for i in $(ls -1 $BASEDIR/config/rootfiles/packages); do
696 if [ -e $BASEDIR/lfs/$i ]; then
697 ipfiredist $i
698 else
699 echo -n $i
700 beautify message SKIP
701 fi
702 done
703 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
704 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
705 rm -rf $BASEDIR/build/install/packages/*
706 }
707
708 # See what we're supposed to do
709 case "$1" in
710 build)
711 clear
712 BUILDMACHINE=`uname -m`
713 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
714 #only restore on a clean disk
715 if [ ! -f log/cleanup-toolchain-2-tools ]; then
716 if [ ! -n "$PACKAGE" ]; then
717 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
718 prepareenv
719 buildtoolchain
720 else
721 PACKAGENAME=${PACKAGE%.tar.gz}
722 beautify build_stage "Packaged toolchain compilation"
723 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
724 tar zxf $PACKAGE
725 prepareenv
726 else
727 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
728 fi
729 fi
730 else
731 echo -n "Using installed toolchain" | tee -a $LOGFILE
732 beautify message SKIP
733 prepareenv
734 fi
735
736 beautify build_start
737 beautify build_stage "Building LFS"
738 buildbase
739
740 beautify build_stage "Building IPFire"
741 buildipfire
742
743 beautify build_stage "Building installer"
744 buildinstaller
745
746 beautify build_stage "Building packages"
747 buildpackages
748
749 beautify build_stage "Checking Logfiles for new Files"
750 cd ..
751 tools/checknewlog.pl
752
753 beautify build_end
754 ;;
755 shell)
756 # enter a shell inside LFS chroot
757 # may be used to changed kernel settings
758 prepareenv
759 entershell
760 ;;
761 clean)
762 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
763 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
764 $LOSETUP -d $i 2>/dev/null
765 done
766 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
767 umount $i
768 done
769 stdumount
770 for i in `seq 0 7`; do
771 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
772 umount /dev/loop${i} 2>/dev/null;
773 losetup -d /dev/loop${i} 2>/dev/null;
774 fi;
775 done
776 rm -rf $BASEDIR/build
777 rm -rf $BASEDIR/cdrom
778 rm -rf $BASEDIR/packages
779 rm -rf $BASEDIR/log
780 if [ -h /tools ]; then
781 rm -f /tools
782 fi
783 beautify message DONE
784 ;;
785 downloadsrc)
786 if [ ! -d $BASEDIR/cache ]; then
787 mkdir $BASEDIR/cache
788 fi
789 mkdir -p $BASEDIR/log
790 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
791 FINISHED=0
792 cd $BASEDIR/lfs
793 for c in `seq $MAX_RETRIES`; do
794 if (( FINISHED==1 )); then
795 break
796 fi
797 FINISHED=1
798 cd $BASEDIR/lfs
799 for i in *; do
800 if [ -f "$i" -a "$i" != "Config" ]; then
801 echo -ne "Loading $i"
802 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
803 if [ $? -ne 0 ]; then
804 beautify message FAIL
805 FINISHED=0
806 else
807 if [ $c -eq 1 ]; then
808 beautify message DONE
809 fi
810 fi
811 fi
812 done
813 done
814 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
815 ERROR=0
816 for i in *; do
817 if [ -f "$i" -a "$i" != "Config" ]; then
818 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
819 if [ $? -ne 0 ]; then
820 echo -ne "MD5 difference in lfs/$i"
821 beautify message FAIL
822 ERROR=1
823 fi
824 fi
825 done
826 if [ $ERROR -eq 0 ]; then
827 echo -ne "${BOLD}all files md5sum match${NORMAL}"
828 beautify message DONE
829 else
830 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
831 beautify message FAIL
832 fi
833 cd - >/dev/null 2>&1
834 ;;
835 toolchain)
836 clear
837 prepareenv
838 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
839 buildtoolchain
840 BUILDMACHINE=`uname -m`
841 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
842 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
843 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
844 build/{bin,etc,usr/bin,usr/local} \
845 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
846 log >> $LOGFILE
847 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
848 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
849 stdumount
850 ;;
851 gettoolchain)
852 BUILDMACHINE=`uname -m`
853 # arbitrary name to be updated in case of new toolchain package upload
854 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
855 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
856 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
857 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
858 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
859 cd $BASEDIR/cache/toolchains
860 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
861 if [ $? -ne 0 ]; then
862 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
863 else
864 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
865 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
866 else
867 exiterror "$PACKAGE.md5 did not match, check downloaded package"
868 fi
869 fi
870 else
871 echo "Toolchain is already downloaded. Exiting..."
872 fi
873 ;;
874 othersrc)
875 prepareenv
876 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
877 chroot $LFS /tools/bin/env -i HOME=/root \
878 TERM=$TERM PS1='\u:\w\$ ' \
879 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
880 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
881 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
882 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
883 if [ $? -eq "0" ]; then
884 beautify message DONE
885 else
886 beautify message FAIL
887 fi
888 stdumount
889 ;;
890 git)
891 case "$2" in
892 update|up)
893 ## REMOVES ALL UNCOMMITTED CHANGES!
894 [ "$3" == "--force" ] && git checkout -f
895 git pull
896 ;;
897 commit|ci)
898 shift 2
899 git commit $*
900
901 [ "$?" -eq "0" ] || exiterror "git commit $* failed."
902
903 echo -e "${BOLD}Do you want to push, too? [y/N]${NORMAL}"
904 read
905 [ -z $REPLY ] && exit 0
906 for i in y Y j J; do
907 if [ "$i" == "$REPLY" ]; then
908 $0 git push
909 exit $?
910 fi
911 done
912 exiterror "\"$REPLY\" is not a valid answer."
913 ;;
914 dist)
915 git archive HEAD | gzip -9 > ${SNAME}-${VERSION}.tar.gz
916 ;;
917 diff|di)
918 echo -ne "Make a local diff to last revision"
919 git diff HEAD > ipfire-diff-$(date +'%Y-%m-%d-%H:%M').diff
920 evaluate 1
921 echo "Diff was successfully saved to ipfire-diff-$(date +'%Y-%m-%d-%H:%M').diff"
922 git diff --stat
923 ;;
924 push)
925 [ -z $GIT_USER ] && exiterror "You have to setup GIT_USER first."
926 GIT_URL="ssh://${GIT_USER}@git.ipfire.org/pub/git/ipfire-2.x"
927
928 git push ${GIT_URL} ${GIT_BRANCH} $3
929 ;;
930 log)
931 [ -z $GIT_TAG ] || LAST_TAG=$GIT_TAG
932 [ -z $LAST_TAG ] || EXT="$LAST_TAG..HEAD"
933
934 git log -n 500 --no-merges --pretty=medium --shortstat $EXT > $BASEDIR/doc/ChangeLog
935 ;;
936 esac
937 ;;
938 uploadsrc)
939 PWD=`pwd`
940 cd $BASEDIR/cache/
941 echo -e "Uploading cache to ftp server:"
942 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL/$FTP_CACHE_PATH/ > /tmp/ftplist
943 for i in *; do
944 if [ "$(basename $i)" == "toolchains" ]; then continue; fi
945 grep -q $(basename $i) /tmp/ftplist
946 if [ "$?" -ne "0" ]; then
947 echo -ne "$(basename $i)"
948 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $(basename $i)
949 if [ "$?" -ne "0" ]; then
950 beautify message FAIL
951 fi
952 fi
953 done
954 rm -f /tmp/ftplist
955 cd $PWD
956 exit 0
957 ;;
958 upload)
959 FTP_ISO_PORT=`echo "$FTP_ISO_URL" | awk -F: '{ print $2 }'`
960 FTP_ISO_URL=`echo "$FTP_ISO_URL" | awk -F: '{ print $1 }'`
961 if [ -z $FTP_ISO_PORT ]; then
962 FTP_ISO_PORT=21
963 fi
964 cat <<EOF > .ftp-commands
965 mkdir -p $FTP_ISO_PATH$SVN_REVISION
966 mkdir -p $FTP_ISO_PATH$SVN_REVISION/paks
967 quit
968 EOF
969 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL < .ftp-commands
970 rm -f .ftp-commands
971
972 case "$2" in
973 iso)
974 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
975
976 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
977 for i in svn_status ipfire-source-r$SVN_REVISION.tar.gz ipfire-$VERSION.$MACHINE-full.iso ipfire-$VERSION.$MACHINE-full.iso.md5 ipfire-$VERSION.$MACHINE-devel.iso ipfire-$VERSION.$MACHINE-devel.iso.md5; do
978 if [ -e "$i" ]; then
979 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ $i
980 if [ "$?" -eq "0" ]; then
981 echo "The file with name $i was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
982 else
983 echo "There was an error while uploading the file $i to the ftp server."
984 exit 1
985 fi
986 fi
987 done
988 rm -f ipfire-$VERSION.$MACHINE-full.iso.md5
989 if [ "$3" = "--with-sources-cd" ]; then
990 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
991 fi
992 ;;
993 paks)
994 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
995 if [ "$?" -eq "0" ]; then
996 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
997 else
998 echo -e "There was an error while uploading the packages to the ftp server."
999 exit 1
1000 fi
1001 ;;
1002 esac
1003 ;;
1004 batch)
1005 if [ "$2" = "--background" ]; then
1006 batch_script
1007 exit $?
1008 fi
1009 if [ `screen -ls | grep -q ipfire` ]; then
1010 echo "Build is already running, sorry!"
1011 exit 1
1012 else
1013 if [ "$2" = "--rebuild" ]; then
1014 export IPFIRE_REBUILD=1
1015 echo "REBUILD!"
1016 else
1017 export IPFIRE_REBUILD=0
1018 fi
1019 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
1020 screen -dmS ipfire $0 batch --background
1021 evaluate 1
1022 exit 0
1023 fi
1024 ;;
1025 watch)
1026 watch_screen
1027 ;;
1028 pxe)
1029 case "$2" in
1030 start)
1031 start_tftpd
1032 ;;
1033 stop)
1034 stop_tftpd
1035 ;;
1036 reload|restart)
1037 reload_tftpd
1038 ;;
1039 esac
1040 exit 0
1041 ;;
1042 lang)
1043 update_langs
1044 ;;
1045 "")
1046 clear
1047 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "LOG: Tail" "Help"
1048 do
1049 case $name in
1050 "IPFIRE: Downloadsrc")
1051 $0 downloadsrc
1052 ;;
1053 "IPFIRE: Build (silent)")
1054 $0 build-silent
1055 ;;
1056 "IPFIRE: Watch Build")
1057 $0 watch
1058 ;;
1059 "IPFIRE: Batch")
1060 $0 batch
1061 ;;
1062 "IPFIRE: Clean")
1063 $0 clean
1064 ;;
1065 "Help")
1066 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1067 cat doc/make.sh-usage
1068 ;;
1069 "LOG: Tail")
1070 tail -f log/_*
1071 ;;
1072 "Exit")
1073 break
1074 ;;
1075 esac
1076 done
1077 ;;
1078 config)
1079 make_config
1080 ;;
1081 *)
1082 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1083 cat doc/make.sh-usage
1084 ;;
1085 esac